/*
 * Copyright (c) 2004, University of Illinois,Distributed Systems Group
 * Large & Dynamic Groups Size Estimation project members:
 * Dimitrios Psaltoulis
 * Dionysios Kostoulas
 * Indranil Gupta
 * Al Demers
 * Ken Birman
 *  All rights reserved.
 *
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * - Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 *
 * - Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the
 * distribution.
 *
 * - Neither the name of the University of Illinois, Urbana-Champaign
 * nor the names of its contributors may be used to endorse or promote
 * products derived from this software without specific prior written
 * permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * Algorithm.java
 *
 * Created on June 17, 2004, 12:50 PM
 */

package SizeEstimationAlgorithm;

import java.net.*;
import java.io.*;

import SizeEstimationAlgorithm.HopCounting.*;
import SizeEstimationAlgorithm.IntervalCounting.*;
/**
 *
 * @author  dimitrios psaltoulis
 */
public class GossipAlgorithm{
    
    public void sendMessage(InetSocketAddress address, Object o) {
        try {
            ByteArrayOutputStream byteStream = new ByteArrayOutputStream(64*1024);
            ObjectOutputStream os = new ObjectOutputStream(byteStream);
            
            os.flush();
            os.writeObject(o);
            os.flush();
            
            byte[] sendBuf = byteStream.toByteArray();
            DatagramPacket packet = new DatagramPacket(sendBuf, sendBuf.length, address);

            DatagramSocket sender = new DatagramSocket();
            sender.send(packet);
            os.close();
        }
        catch (UnknownHostException e) {
            System.err.println(e);
        }
        catch (IOException e) {
            System.err.println(e);
        }
    }
    
    public void stop() {
        server.datagramSocket.close();
    }
    
    public void startCounting() { }
    public void receiveMessage(GossipMessage g) throws UnknownHostException { }
    public long getSize() { return 0; }
    
    public static final int SEND_TO = 2;
    public static final int DEFAULT_PORT = 32000;
    public static final int MAX_PEERS = 5;
    public static final boolean DEBUG = false;
    
    public Server server;
}
