/*
 * Copyright (c) 2004, University of Illinois,Distributed Systems Group 
 * Large & Dynamic Groups Size Estimation project members:
 * Dimitrios Psaltoulis
 * Dionysios Kostoulas
 * Indranil Gupta
 * Al Demers
 * Ken Birman
 *  All rights reserved.
 *
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * - Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 *
 * - Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the
 * distribution.
 *
 * - Neither the name of the University of Illinois, Urbana-Champaign
 * nor the names of its contributors may be used to endorse or promote
 * products derived from this software without specific prior written
 * permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * GossipId.java
 *
 * Created on June 17, 2004, 12:53 PM
 */

package SizeEstimationAlgorithm;

import java.net.*;
import java.io.*;
/**
 *
 * @author  dimitrios psaltoulis
 */
public class GossipId implements Serializable {
    public GossipId(InetAddress ip, int p, int sqNum) {
        address = new InetSocketAddress(ip, p);
        seqNumber = sqNum;
    }
    
    public GossipId(String ip, int p, int sqNum) {
        address = new InetSocketAddress(ip, p);
        seqNumber = sqNum;
    }
    
    public InetSocketAddress getAddress() { return address; }
    public InetAddress getIP() { return address.getAddress(); }
    public int getPort() {return address.getPort(); }
    public int getSeqNumber() { return seqNumber; }
    
    public int hashCode() { return address.hashCode() ^ seqNumber; }
    public boolean equals(Object o) {
        if (!(o instanceof GossipId))
            return false;
        GossipId other = (GossipId) o;
        return address == other.address && seqNumber == other.seqNumber;
    }
    
    private InetSocketAddress address;
    private int seqNumber;
}

